# -*- coding: utf-8 -*-
# Generated by Django 1.11.2 on 2017-06-26 05:13
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Comment',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('score_position', models.FloatField(blank=True, null=True)),
                ('score_equipment', models.FloatField(blank=True, null=True)),
                ('score_service', models.FloatField(blank=True, null=True)),
                ('score_health', models.FloatField(blank=True, null=True)),
                ('score', models.IntegerField(blank=True, null=True)),
                ('purpose', models.TextField(blank=True, null=True)),
                ('content', models.TextField(blank=True, null=True)),
                ('datetime', models.CharField(max_length=45, null=True)),
                ('useful_num', models.IntegerField(blank=True, null=True)),
            ],
            options={
                'db_table': 'comment',
            },
        ),
        migrations.CreateModel(
            name='CrawlWebsite',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('url', models.CharField(max_length=200)),
                ('desc', models.TextField(blank=True, null=True)),
                ('lock', models.BooleanField(default=False)),
                ('done', models.BooleanField(default=False)),
                ('lastest_time', models.TextField(null=True)),
            ],
            options={
                'db_table': 'crawl_website',
            },
        ),
        migrations.CreateModel(
            name='Customer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=45)),
                ('user_level', models.CharField(max_length=45)),
                ('total_comment', models.IntegerField(null=True)),
                ('useful_num', models.IntegerField(null=True)),
                ('upload_img_num', models.IntegerField(null=True)),
            ],
            options={
                'db_table': 'customer',
            },
        ),
        migrations.CreateModel(
            name='Hotel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=45)),
                ('addr', models.CharField(max_length=45, null=True)),
                ('desc', models.TextField(blank=True, null=True)),
                ('policy', models.TextField(blank=True, null=True)),
                ('facilities', models.TextField(blank=True, null=True)),
                ('traffic', models.TextField(blank=True, null=True)),
                ('score', models.TextField(blank=True, null=True)),
                ('tags', models.TextField(blank=True, null=True)),
            ],
            options={
                'db_table': 'hotel',
            },
        ),
        migrations.CreateModel(
            name='RoomType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=45)),
                ('desc', models.CharField(max_length=255, null=True)),
                ('price', models.CharField(max_length=255, null=True)),
                ('hotel', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='backend.Hotel')),
            ],
            options={
                'db_table': 'room_type',
            },
        ),
        migrations.AddField(
            model_name='comment',
            name='customer',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='backend.Customer'),
        ),
        migrations.AddField(
            model_name='comment',
            name='hotel',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='backend.Hotel'),
        ),
        migrations.AddField(
            model_name='comment',
            name='room_type',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='backend.RoomType'),
        ),
    ]
